Imports System.Text.RegularExpressions

Public Class Form1
    Private m_Person As New Person

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        prgPerson.SelectedObject = m_Person
    End Sub

    ' Find the GridItem with the given label in this PropertyGrid.
    Public Function FindPropertyGridItem(ByVal property_grid As PropertyGrid, ByVal item_label As String) As GridItem
        ' Find the GridItem root.
        Dim root As GridItem
        root = property_grid.SelectedGridItem
        Do Until root.Parent Is Nothing
            root = root.Parent
        Loop

        ' Search the tree.
        Dim nodes As New Collection
        nodes.Add(root)
        Do Until nodes.Count = 0
            Dim test_node As GridItem = DirectCast(nodes(1), GridItem)
            nodes.Remove(1)
            If test_node.Label = item_label Then Return test_node

            For Each obj As Object In test_node.GridItems
                nodes.Add(obj)
            Next obj
        Loop

        Return Nothing
    End Function

    ' Select ths property grid's indicated item.
    Public Sub SelectPropertyGridItem(ByVal property_grid As PropertyGrid, ByVal item_label As String)
        property_grid.SelectedGridItem = FindPropertyGridItem(property_grid, item_label)
    End Sub

    ' Verify that the properties are not blank.
    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click
        If PropertyIsBlank("City", m_Person.City) Then Exit Sub
        If PropertyIsBlank("FirstName", m_Person.FirstName) Then Exit Sub
        If PropertyIsBlank("LastName", m_Person.LastName) Then Exit Sub
        If PropertyIsBlank("State", m_Person.State) Then Exit Sub
        If PropertyIsBlank("Street", m_Person.Street) Then Exit Sub
        If PropertyIsBlank("Zip", m_Person.Zip) Then Exit Sub

        MessageBox.Show("Ok", "Ok", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    Private Function PropertyIsBlank(ByVal property_name As String, ByVal property_value As String) As Boolean
        If (property_value Is Nothing) OrElse (property_value.Length < 1) Then
            MessageBox.Show(property_name & " is blank", _
                "Blank " & property_name, _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Exclamation)
            SelectPropertyGridItem(prgPerson, property_name)
            prgPerson.Select()
            Return True
        Else
            Return False
        End If
    End Function
End Class

Public Class Person
	' The FirstName property.
	Private m_FirstName As String
	Public Property FirstName() As String
		Get
			Return m_FirstName
		End Get
		Set(ByVal value As String)
			m_FirstName = value
		End Set
	End Property

	' The LastName property.
	Private m_LastName As String
	Public Property LastName() As String
		Get
			Return m_LastName
		End Get
		Set(ByVal value As String)
			m_LastName = value
		End Set
	End Property

	' The Street property.
	Private m_Street As String
	Public Property Street() As String
		Get
			Return m_Street
		End Get
		Set(ByVal value As String)
			m_Street = value
		End Set
	End Property

	' The City property.
	Private m_City As String
	Public Property City() As String
		Get
			Return m_City
		End Get
		Set(ByVal value As String)
			m_City = value
		End Set
	End Property

	' The State property.
	Private m_State As String
	Public Property State() As String
		Get
			Return m_State
		End Get
		Set(ByVal value As String)
			m_State = value
		End Set
	End Property

	' The Zip property.
	Private m_Zip As String
	Public Property Zip() As String
		Get
			Return m_Zip
		End Get
		Set(ByVal value As String)
			m_Zip = value
		End Set
	End Property
End Class